(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('dl-chart', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory(global['dl-chart'] = {}, global.ng.core, global.ng.common));
}(this, function (exports, core, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChartItemService = /** @class */ (function () {
        function ChartItemService() {
            this.values = [];
            this.chartValueChange = new core.EventEmitter();
            this.chartValueHover = new core.EventEmitter();
            this.chartValueLeave = new core.EventEmitter();
            this.chartValueSelect = new core.EventEmitter();
            this.chartValueDeselect = new core.EventEmitter();
        }
        /**
         * @param {?} val
         * @return {?}
         */
        ChartItemService.prototype.setChartValues = /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            /** @type {?} */
            var values = this.values.find((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                if (item.chartId === val.chartId) {
                    return true;
                }
                return false;
            }));
            if (values) {
                values = val;
            }
            else {
                this.values.push(val);
            }
            this.chartValueChange.emit(val);
        };
        /**
         * @param {?} chartId
         * @return {?}
         */
        ChartItemService.prototype.getChartValues = /**
         * @param {?} chartId
         * @return {?}
         */
        function (chartId) {
            return this.values.find((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                if (item.chartId === chartId) {
                    return true;
                }
                return false;
            }));
        };
        /**
         * @param {?} val
         * @return {?}
         */
        ChartItemService.prototype.hoverChartValue = /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.chartValueHover.emit(val);
        };
        /**
         * @param {?} val
         * @return {?}
         */
        ChartItemService.prototype.leaveChartValue = /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.chartValueLeave.emit(val);
        };
        /**
         * @param {?} val
         * @return {?}
         */
        ChartItemService.prototype.selectChartValue = /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.chartValueSelect.emit(val);
        };
        /**
         * @param {?} val
         * @return {?}
         */
        ChartItemService.prototype.deselectChartValue = /**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            this.chartValueDeselect.emit(val);
        };
        ChartItemService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        ChartItemService.ctorParameters = function () { return []; };
        return ChartItemService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TooltipConfiguration = /** @class */ (function () {
        function TooltipConfiguration(HideValue, ValueFunction) {
            if (HideValue === void 0) { HideValue = false; }
            if (ValueFunction === void 0) { ValueFunction = null; }
            this.HideValue = false;
            this.ValueFunction = null;
            this.HideValue = HideValue;
            this.ValueFunction = ValueFunction;
        }
        return TooltipConfiguration;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var   /**
     * @template T
     */
    ServiceItem = /** @class */ (function () {
        function ServiceItem(chartId, value, tooltipX, tooltipY) {
            this.chartId = chartId;
            this.value = value;
            this.tooltipX = tooltipX;
            this.tooltipY = tooltipY;
        }
        return ServiceItem;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var BaseChartComponent = /** @class */ (function () {
        function BaseChartComponent(chartItemService, utilsService, cd) {
            this.chartItemService = chartItemService;
            this.utilsService = utilsService;
            this.cd = cd;
            this.currentValues = [];
            this.tooltipShow = false;
            this.tooltipClass = '';
            this.animationActive = true;
            this.valueSelect = new core.EventEmitter();
            this.valueDeselect = new core.EventEmitter();
            this.valueClick = new core.EventEmitter();
            this.valueChange = new core.EventEmitter();
            this.chartidChange = new core.EventEmitter();
            this.currentChartid = 'dl-chart-1';
            this.currentTooltipConfiguration = null;
            this.currentHideTooltip = false;
            this.currentAllowSelect = true;
        }
        Object.defineProperty(BaseChartComponent.prototype, "values", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentValues = val;
                this.cd.detectChanges();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseChartComponent.prototype, "animation", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.animationActive = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseChartComponent.prototype, "chartid", {
            get: /**
             * @return {?}
             */
            function () {
                return this.currentChartid;
            },
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentChartid = val;
                this.chartidChange.emit(this.currentChartid);
                this.cd.detectChanges();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseChartComponent.prototype, "tooltipConfiguration", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentTooltipConfiguration = val;
                this.cd.detectChanges();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseChartComponent.prototype, "hideTooltip", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentHideTooltip = val;
                this.cd.detectChanges();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseChartComponent.prototype, "allowSelect", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentAllowSelect = val;
                this.cd.detectChanges();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BaseChartComponent.prototype, "tooltipValue", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.tooltipContentItem) {
                    if (this.tooltipContentItem.tooltipConfig != null) {
                        return this.utilsService.textValue(this.tooltipContentItem.tooltipConfig, this.tooltipContentItem, this.tooltipContentChartItem.calculatedPercent);
                    }
                    else {
                        return this.utilsService.textValue(this.currentTooltipConfiguration, this.tooltipContentItem, this.tooltipContentChartItem.calculatedPercent);
                    }
                }
                return null;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} event
         * @return {?}
         */
        BaseChartComponent.prototype.onClickSegment = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (this.currentAllowSelect) {
                if (event === this.currentActiveChartItem) {
                    this.currentActiveChartItem = null;
                    this.valueDeselect.emit(event.sourceItem);
                    this.chartItemService.chartValueDeselect.emit(new ServiceItem(this.chartid, event, null, null));
                }
                else {
                    this.currentActiveChartItem = event;
                    this.valueSelect.emit(event.sourceItem);
                    this.chartItemService.chartValueSelect.emit(new ServiceItem(this.chartid, event, null, null));
                }
            }
            this.valueClick.emit(event.sourceItem);
        };
        /**
         * @param {?} event
         * @param {?} item
         * @return {?}
         */
        BaseChartComponent.prototype.onHoverSegment = /**
         * @param {?} event
         * @param {?} item
         * @return {?}
         */
        function (event, item) {
            this.tooltipContentChartItem = item;
            this.tooltipContentItem = item.sourceItem;
            this.tooltipLeft = (event.clientX + 10);
            this.tooltipTop = (event.clientY + 10);
            if (this.currentHideTooltip === false) {
                this.tooltipShow = true;
            }
            else {
                this.tooltipShow = false;
            }
            this.valueChange.emit(item.sourceItem);
            this.chartItemService.chartValueHover.emit(new ServiceItem(this.chartid, item, this.tooltipLeft, this.tooltipTop));
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BaseChartComponent.prototype.onLeaveSegment = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.tooltipContentChartItem = null;
            this.tooltipContentItem = null;
            this.tooltipShow = false;
            this.valueChange.emit(null);
            this.chartItemService.chartValueLeave.emit(new ServiceItem(this.chartid, null, null, null));
        };
        /**
         * @return {?}
         */
        BaseChartComponent.prototype.resetActive = /**
         * @return {?}
         */
        function () {
            this.tooltipContentChartItem = null;
            this.tooltipContentItem = null;
            this.tooltipShow = false;
            this.valueChange.emit(null);
        };
        BaseChartComponent.propDecorators = {
            values: [{ type: core.Input }],
            animation: [{ type: core.Input }],
            valueSelect: [{ type: core.Output }],
            valueDeselect: [{ type: core.Output }],
            valueClick: [{ type: core.Output }],
            valueChange: [{ type: core.Output }],
            chartidChange: [{ type: core.Output }],
            chartid: [{ type: core.Input }],
            tooltipConfiguration: [{ type: core.Input }],
            hideTooltip: [{ type: core.Input }],
            allowSelect: [{ type: core.Input }]
        };
        return BaseChartComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UtilsService = /** @class */ (function () {
        function UtilsService() {
        }
        /**
         * @param {?} config
         * @param {?} item
         * @param {?} percent
         * @return {?}
         */
        UtilsService.prototype.textValue = /**
         * @param {?} config
         * @param {?} item
         * @param {?} percent
         * @return {?}
         */
        function (config, item, percent) {
            if (config != null) {
                if (config.ValueFunction != null) {
                    return config.ValueFunction(item, percent);
                }
                else {
                    if (config.HideValue) {
                        return item.name;
                    }
                    else {
                        return this.getTextValue(item);
                    }
                }
            }
            return this.getTextValue(item);
        };
        /**
         * @private
         * @param {?} item
         * @return {?}
         */
        UtilsService.prototype.getTextValue = /**
         * @private
         * @param {?} item
         * @return {?}
         */
        function (item) {
            /** @type {?} */
            var valueItem = (/** @type {?} */ (item));
            if (valueItem.value != undefined) {
                return item.name + ' (' + valueItem.value + ')';
            }
            /** @type {?} */
            var pointItem = (/** @type {?} */ (item));
            if (pointItem.yValue != undefined) {
                return item.name + ' (' + pointItem.yValue + ', ' + pointItem.xValue + ')';
            }
            return item.name;
        };
        /**
         * @param {?} value
         * @return {?}
         */
        UtilsService.prototype.roundScale = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return Math.round(value * 100) / 100;
        };
        /**
         * @param {?} prefix
         * @param {?} index
         * @return {?}
         */
        UtilsService.prototype.createElementId = /**
         * @param {?} prefix
         * @param {?} index
         * @return {?}
         */
        function (prefix, index) {
            /** @type {?} */
            var id = prefix + index;
            return id;
        };
        /**
         * @param {?} minValue
         * @param {?} valueSteps
         * @param {?} singleStepValue
         * @param {?} singleStep
         * @param {?} maxValue
         * @return {?}
         */
        UtilsService.prototype.createYAxis = /**
         * @param {?} minValue
         * @param {?} valueSteps
         * @param {?} singleStepValue
         * @param {?} singleStep
         * @param {?} maxValue
         * @return {?}
         */
        function (minValue, valueSteps, singleStepValue, singleStep, maxValue) {
            /** @type {?} */
            var axis = [];
            axis.push({
                text: this.onFormatUnkownAxisValue(minValue),
                position: 100
            });
            /** @type {?} */
            var index = 1;
            for (index = 1; index <= (valueSteps - 1); index++) {
                /** @type {?} */
                var currentValue = this.roundScale(minValue + (singleStepValue * index));
                /** @type {?} */
                var step = 100 - this.roundScale(singleStep * index);
                axis.push({
                    text: this.onFormatUnkownAxisValue(currentValue),
                    position: step
                });
            }
            axis.push({
                text: this.onFormatUnkownAxisValue(maxValue),
                position: 0
            });
            return axis;
        };
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        UtilsService.prototype.onFormatUnkownAxisValue = /**
         * @private
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value != undefined && value != null && !isNaN(value) && value != Infinity && value != -Infinity) {
                return value.toString();
            }
            else {
                return "";
            }
        };
        UtilsService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        UtilsService.ctorParameters = function () { return []; };
        return UtilsService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PieChartComponent = /** @class */ (function (_super) {
        __extends(PieChartComponent, _super);
        function PieChartComponent(chartItemService, utilsService, cd) {
            var _this = _super.call(this, chartItemService, utilsService, cd) || this;
            _this.donutRadius = 0;
            _this.slices = [];
            return _this;
        }
        Object.defineProperty(PieChartComponent.prototype, "donut", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.donutRadius = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PieChartComponent.prototype, "pie", {
            get: /**
             * @return {?}
             */
            function () {
                return this.slices;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} slice
         * @param {?} index
         * @return {?}
         */
        PieChartComponent.prototype.cssClassSegment = /**
         * @param {?} slice
         * @param {?} index
         * @return {?}
         */
        function (slice, index) {
            /** @type {?} */
            var css = '';
            css += 'slice';
            if (slice === this.currentActiveChartItem) {
                css += ' slice-selected';
            }
            if (slice.sourceItem.cssClass != null) {
                css += ' ' + slice.sourceItem.cssClass;
            }
            if (this.animationActive) {
                if (index % 2 == 0) {
                    css += ' ' + 'slice-anim-even';
                }
                else {
                    css += ' ' + 'slice-anim';
                }
            }
            return css;
        };
        /**
         * @param {?} slice
         * @param {?} index
         * @return {?}
         */
        PieChartComponent.prototype.createElementId = /**
         * @param {?} slice
         * @param {?} index
         * @return {?}
         */
        function (slice, index) {
            /** @type {?} */
            var id = this.utilsService.createElementId('chart-slice-', index);
            slice.id = id;
            return id;
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        PieChartComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            this.resetActiveElement();
            this.calculateSlices();
        };
        /**
         * @return {?}
         */
        PieChartComponent.prototype.calculateSlices = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var cumulativePercent = 0;
            /** @type {?} */
            var totalValue = 0;
            this.slices = [];
            this.currentValues.forEach((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                if (!item.value) {
                    item.value = 0;
                }
                totalValue += item.value;
            }));
            this.currentValues.forEach((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                cumulativePercent = _this.createSlice(item, totalValue, cumulativePercent);
            }));
            this.chartItemService.setChartValues(new ServiceItem(this.chartid, this.pie, null, null));
        };
        /**
         * @param {?} item
         * @param {?} totalValue
         * @param {?} cumulativePercent
         * @return {?}
         */
        PieChartComponent.prototype.createSlice = /**
         * @param {?} item
         * @param {?} totalValue
         * @param {?} cumulativePercent
         * @return {?}
         */
        function (item, totalValue, cumulativePercent) {
            var _a = __read(this.getCoordinatesForPercent(cumulativePercent), 2), startX = _a[0], startY = _a[1];
            /** @type {?} */
            var normValue = this.getNormalizedValue(totalValue, item.value);
            if (!normValue) {
                normValue = 0;
            }
            cumulativePercent += normValue;
            var _b = __read(this.getCoordinatesForPercent(cumulativePercent), 2), endX = _b[0], endY = _b[1];
            /** @type {?} */
            var largeArcFlag = this.getNormalizedValue(totalValue, item.value) > .5 ? 1 : 0;
            /** @type {?} */
            var pathData = [
                "M " + startX + " " + startY,
                "A 1 1 0 " + largeArcFlag + " 1 " + endX + " " + endY,
                "L 0 0",
            ].join(' ');
            if (normValue === 0) {
                pathData = null;
            }
            this.slices.push({
                color: item.color,
                draw: pathData,
                sourceItem: item,
                id: null,
                calculatedPercent: this.utilsService.roundScale((normValue * 100))
            });
            return cumulativePercent;
        };
        /**
         * @param {?} percent
         * @return {?}
         */
        PieChartComponent.prototype.getCoordinatesForPercent = /**
         * @param {?} percent
         * @return {?}
         */
        function (percent) {
            /** @type {?} */
            var x = Math.cos(2 * Math.PI * percent);
            /** @type {?} */
            var y = Math.sin(2 * Math.PI * percent);
            return [x, y];
        };
        /**
         * @param {?} totalValue
         * @param {?} value
         * @return {?}
         */
        PieChartComponent.prototype.getNormalizedValue = /**
         * @param {?} totalValue
         * @param {?} value
         * @return {?}
         */
        function (totalValue, value) {
            /** @type {?} */
            var percent = value / (totalValue / 100);
            if (percent < 0) {
                return 0;
            }
            return percent / 100;
        };
        /**
         * @return {?}
         */
        PieChartComponent.prototype.resetActiveElement = /**
         * @return {?}
         */
        function () {
            _super.prototype.resetActive.call(this);
        };
        PieChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'dl-pie-chart',
                        template: "<ng-container>\r\n  <svg viewBox=\"-1 -1 2 2\" style=\"transform: rotate(-90deg);height: 100%;\" class=\"pie-chart-svg\" id=\"piechart\">\r\n    <path *ngFor=\"let slice of pie; let i = index\" [attr.id]=\"createElementId(slice, i)\" (mousemove)=\"onHoverSegment($event, slice)\"\r\n      (mouseleave)=\"onLeaveSegment($event)\" (click)=\"onClickSegment(slice)\" [attr.class]=\"cssClassSegment(slice, i)\"\r\n      [attr.d]=\"slice.draw\" [attr.fill]=\"slice.color\"></path>\r\n    <circle *ngIf=\"donutRadius > 0\" class=\"inner-circle\" [attr.r]=\"donutRadius\" cx=\"0\" cy=\"0\" />\r\n  </svg>\r\n  <div id=\"dlChartTooltip\" *ngIf=\"tooltipShow\" [style.top.px]=\"tooltipTop\" [style.left.px]=\"tooltipLeft\" class=\"tooltiptext\">\r\n    <span>{{ tooltipValue }}</span>\r\n  </div>\r\n</ng-container>",
                        encapsulation: core.ViewEncapsulation.Emulated,
                        styles: [".tooltiptext{position:fixed;overflow:hidden;text-align:center;padding:5px 10px;border-radius:6px;z-index:80;background-color:#555;color:#fff}.pie-chart-svg{overflow:visible}.slice{-webkit-transform:scale(1,1);transform:scale(1,1);transition:.5s}.slice:hover{opacity:.8;-webkit-transform:scale(1.02,1.02);transform:scale(1.02,1.02);transition:.5s}.slice-selected{-webkit-transform:scale(1.02,1.02);transform:scale(1.02,1.02);transition:.5s}.slice-anim{animation:.4s reverse scaleSlice}.slice-anim-even{animation:.5s reverse scaleSlice}.inner-circle{fill:#fff}@-webkit-keyframes scaleSlice{100%{-webkit-transform:scale(0,0);transform:scale(0,0)}}@keyframes scaleSlice{100%{-webkit-transform:scale(0,0);transform:scale(0,0)}}"]
                    }] }
        ];
        /** @nocollapse */
        PieChartComponent.ctorParameters = function () { return [
            { type: ChartItemService },
            { type: UtilsService },
            { type: core.ChangeDetectorRef }
        ]; };
        PieChartComponent.propDecorators = {
            donut: [{ type: core.Input }]
        };
        return PieChartComponent;
    }(BaseChartComponent));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DlPieChartModule = /** @class */ (function () {
        function DlPieChartModule() {
        }
        DlPieChartModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule
                        ],
                        declarations: [
                            PieChartComponent
                        ],
                        providers: [
                            ChartItemService,
                            UtilsService
                        ],
                        entryComponents: [
                            PieChartComponent
                        ],
                        exports: [
                            PieChartComponent
                        ]
                    },] }
        ];
        return DlPieChartModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LegendConfiguration = /** @class */ (function () {
        function LegendConfiguration(HideValue, ValueFunction) {
            if (HideValue === void 0) { HideValue = false; }
            if (ValueFunction === void 0) { ValueFunction = null; }
            this.HideValue = false;
            this.ValueFunction = null;
            this.HideValue = HideValue;
            this.ValueFunction = ValueFunction;
        }
        return LegendConfiguration;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LegendComponent = /** @class */ (function () {
        function LegendComponent(chartItemService, utilsService, cd) {
            this.chartItemService = chartItemService;
            this.utilsService = utilsService;
            this.cd = cd;
            this.legendClick = new core.EventEmitter();
            this.items = null;
            this.hoverItem = null;
            this.selectedItem = null;
            this.shouldHideChartHoverEffect = false;
            this.shouldHideChartSelectEffect = false;
            this.chartidChange = new core.EventEmitter();
            this.currentChartid = 'dl-chart-1';
            this.currentLegendConfiguration = null;
        }
        Object.defineProperty(LegendComponent.prototype, "chartid", {
            get: /**
             * @return {?}
             */
            function () {
                return this.currentChartid;
            },
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentChartid = val;
                this.chartidChange.emit(this.currentChartid);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LegendComponent.prototype, "chartItems", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.items) {
                    return this.items.value;
                }
                return [];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LegendComponent.prototype, "hideChartHoverEffect", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.shouldHideChartHoverEffect = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LegendComponent.prototype, "hideChartSelectEffect", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.shouldHideChartSelectEffect = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LegendComponent.prototype, "legendConfiguration", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentLegendConfiguration = val;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        LegendComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.items = this.chartItemService.getChartValues(this.chartid);
            this.chartItemService.chartValueChange.subscribe((/**
             * @param {?} items
             * @return {?}
             */
            function (items) {
                if (items.chartId === _this.chartid) {
                    _this.items = items;
                }
            }));
            this.chartItemService.chartValueSelect.subscribe((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                if (item.chartId === _this.chartid) {
                    _this.selectedItem = item.value;
                }
            }));
            this.chartItemService.chartValueDeselect.subscribe((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                if (item.chartId === _this.chartid) {
                    _this.selectedItem = null;
                }
            }));
            this.chartItemService.chartValueHover.subscribe((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                if (item.chartId === _this.chartid) {
                    _this.hoverItem = item.value;
                }
            }));
            this.chartItemService.chartValueLeave.subscribe((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                if (item.chartId === _this.chartid) {
                    _this.hoverItem = null;
                }
            }));
        };
        /**
         * @return {?}
         */
        LegendComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @return {?}
         */
        LegendComponent.prototype.ngAfterContentChecked = /**
         * @return {?}
         */
        function () {
            this.cd.detectChanges();
        };
        /**
         * @param {?} item
         * @return {?}
         */
        LegendComponent.prototype.legendTextValue = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            return this.utilsService.textValue(this.currentLegendConfiguration, item.sourceItem, item.calculatedPercent);
        };
        /**
         * @param {?} item
         * @return {?}
         */
        LegendComponent.prototype.tooltipTextValue = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            return this.utilsService.textValue(item.sourceItem.tooltipConfig, item.sourceItem, item.calculatedPercent);
        };
        /**
         * @param {?} event
         * @param {?} item
         * @return {?}
         */
        LegendComponent.prototype.onItemClick = /**
         * @param {?} event
         * @param {?} item
         * @return {?}
         */
        function (event, item) {
            this.legendClick.emit(item.sourceItem);
        };
        /**
         * @param {?} item
         * @return {?}
         */
        LegendComponent.prototype.legendClass = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            /** @type {?} */
            var ret = ' ';
            if (this.shouldHideChartSelectEffect === false) {
                if (this.selectedItem != null && item.id === this.selectedItem.id) {
                    ret += 'legend-selected ';
                }
            }
            if (this.shouldHideChartHoverEffect === false) {
                if (this.hoverItem != null && item.id === this.hoverItem.id) {
                    ret += 'legend-hover ';
                }
            }
            return ret;
        };
        LegendComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'dl-chart-legend',
                        template: "<div>\r\n  <div class=\"legend-items\">\r\n    <div (click)=\"onItemClick($event, item)\" [class]=\"'tooltip legend-item' + legendClass(item)\" *ngFor=\"let item of chartItems\">\r\n      <span id=\"legend-color\" class=\"legend-color-box\" [style.background-color]=\"item.color\"></span>\r\n      <span class=\"legend-text-content \">  \r\n        {{ legendTextValue(item) }}\r\n        <span id=\"dlChartTooltip\" class=\"legend-tooltip tooltiptext \">{{ tooltipTextValue(item) }}</span>\r\n      </span>\r\n    </div>\r\n  </div>\r\n</div>",
                        encapsulation: core.ViewEncapsulation.Emulated,
                        styles: [".tooltiptext{position:fixed;overflow:hidden;text-align:center;padding:5px 10px;border-radius:6px;z-index:80;background-color:#555;color:#fff}.legend-items{display:flex;flex-wrap:wrap;margin-left:-10px;margin-top:-10px}.legend-items .legend-item{flex:1 0 auto;margin-left:10px;margin-top:10px;text-align:left;min-width:50px}.legend-items:hover{cursor:default}.legend-color-box{min-height:15px;min-width:15px;display:inline-block;border:1px solid #000}.legend-text-content{min-width:25px;vertical-align:top}.tooltip .legend-tooltip{visibility:hidden;text-align:center;padding:5px 10px;border-radius:6px;position:absolute;z-index:80}.tooltip:hover .legend-tooltip{visibility:visible}.legend-hover{opacity:.8}.legend-selected{font-weight:700}"]
                    }] }
        ];
        /** @nocollapse */
        LegendComponent.ctorParameters = function () { return [
            { type: ChartItemService },
            { type: UtilsService },
            { type: core.ChangeDetectorRef }
        ]; };
        LegendComponent.propDecorators = {
            legendClick: [{ type: core.Output }],
            chartidChange: [{ type: core.Output }],
            chartid: [{ type: core.Input }],
            hideChartHoverEffect: [{ type: core.Input }],
            hideChartSelectEffect: [{ type: core.Input }],
            legendConfiguration: [{ type: core.Input }]
        };
        return LegendComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DlLegendModule = /** @class */ (function () {
        function DlLegendModule() {
        }
        DlLegendModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                        ],
                        declarations: [
                            LegendComponent
                        ],
                        providers: [
                            ChartItemService,
                            UtilsService
                        ],
                        entryComponents: [
                            LegendComponent
                        ],
                        exports: [
                            LegendComponent
                        ]
                    },] }
        ];
        return DlLegendModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var ChartOrientation = {
        Bottom: 0,
        Left: 1,
        Right: 2,
        Top: 3,
    };
    ChartOrientation[ChartOrientation.Bottom] = 'Bottom';
    ChartOrientation[ChartOrientation.Left] = 'Left';
    ChartOrientation[ChartOrientation.Right] = 'Right';
    ChartOrientation[ChartOrientation.Top] = 'Top';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BarChartComponent = /** @class */ (function (_super) {
        __extends(BarChartComponent, _super);
        function BarChartComponent(chartItemService, utilsService, cd) {
            var _this = _super.call(this, chartItemService, utilsService, cd) || this;
            _this.barWidhtOffset = 5;
            _this.currentActiveBar = null;
            _this.shouldHideSelectLine = false;
            _this.currentScaleLabel = '';
            _this.valueSteps = 6;
            _this.activeLeftScaleAxis = true;
            _this.activeRightScaleAxis = false;
            _this.currentOrientation = ChartOrientation.Bottom;
            _this.currentBarFullFilled = false;
            _this.barGroundLineY = 100;
            _this.xAxis = [];
            _this.yAxis = [];
            _this.bars = [];
            return _this;
        }
        Object.defineProperty(BarChartComponent.prototype, "barFullFilled", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentBarFullFilled = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BarChartComponent.prototype, "hideSelectLine", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.shouldHideSelectLine = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BarChartComponent.prototype, "barOffset", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.barWidhtOffset = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BarChartComponent.prototype, "scaleLabel", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentScaleLabel = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BarChartComponent.prototype, "steps", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.valueSteps = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BarChartComponent.prototype, "leftScaleAxis", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.activeLeftScaleAxis = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BarChartComponent.prototype, "rightScaleAxis", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.activeRightScaleAxis = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BarChartComponent.prototype, "orientation", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentOrientation = val;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} changes
         * @return {?}
         */
        BarChartComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            this.resetActiveElement();
            this.calculateChart();
        };
        /**
         * @return {?}
         */
        BarChartComponent.prototype.calculateChart = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var items = this.currentValues;
            items.forEach((/**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                if (!val.value) {
                    val.value = 0;
                }
            }));
            /** @type {?} */
            var minValueCalc = Math.min.apply(Math, items.map((/**
             * @param {?} o
             * @return {?}
             */
            function (o) { return o.value; })));
            if (minValueCalc > 0) {
                minValueCalc = 0;
            }
            /** @type {?} */
            var maxValueCalc = Math.max.apply(Math, items.map((/**
             * @param {?} o
             * @return {?}
             */
            function (o) { return o.value; })));
            /** @type {?} */
            var maxValue = (maxValueCalc - minValueCalc);
            /** @type {?} */
            var singleStepValue = (maxValue / this.valueSteps);
            /** @type {?} */
            var singleStepY = (100 / this.valueSteps);
            this.yAxis = this.utilsService.createYAxis(minValueCalc, this.valueSteps, singleStepValue, singleStepY, maxValueCalc);
            this.barGroundLineY = 100;
            if (minValueCalc < 0) {
                this.barGroundLineY = (100 - (100 / maxValue) * (minValueCalc * -1));
            }
            /** @type {?} */
            var singleBarWidht = (((100 - this.barWidhtOffset) - (items.length * this.barWidhtOffset)) / items.length);
            /** @type {?} */
            var bars = [];
            /** @type {?} */
            var index = 1;
            this.currentValues.forEach((/**
             * @param {?} item
             * @return {?}
             */
            function (item) {
                bars.push({
                    val: item,
                    position: (_this.barWidhtOffset * index) + (singleBarWidht * (index - 1))
                });
                index++;
            }));
            if (maxValue != 0) {
                this.createXAxis(singleBarWidht, bars);
            }
            this.createBars(maxValue, singleBarWidht, bars);
            this.chartItemService.setChartValues(new ServiceItem(this.chartid, this.bars, null, null));
        };
        /**
         * @param {?} singleBarWidht
         * @param {?} items
         * @return {?}
         */
        BarChartComponent.prototype.createXAxis = /**
         * @param {?} singleBarWidht
         * @param {?} items
         * @return {?}
         */
        function (singleBarWidht, items) {
            this.xAxis = [];
            for (var index = 0; index < items.length; index++) {
                /** @type {?} */
                var element = items[index];
                /** @type {?} */
                var pos = ((element.position + singleBarWidht) - (singleBarWidht / 2));
                this.xAxis.push({
                    text: element.val.shortName != null ? element.val.shortName : element.val.name,
                    position: pos,
                });
            }
        };
        /**
         * @param {?} maxValue
         * @param {?} singleBarWidht
         * @param {?} items
         * @return {?}
         */
        BarChartComponent.prototype.createBars = /**
         * @param {?} maxValue
         * @param {?} singleBarWidht
         * @param {?} items
         * @return {?}
         */
        function (maxValue, singleBarWidht, items) {
            /** @type {?} */
            var onePercent = maxValue / 100;
            this.bars = [];
            for (var index = 0; index < items.length; index++) {
                /** @type {?} */
                var element = items[index];
                /** @type {?} */
                var height = element.val.value === 0 ? 0 : (1 * (element.val.value / onePercent));
                /** @type {?} */
                var y = element.val.value === 0 ? 0 : (this.barGroundLineY - (1 * (element.val.value / onePercent)));
                /** @type {?} */
                var isMinusValue = false;
                if (height < 0) {
                    isMinusValue = true;
                    height = height * -1;
                    y = this.barGroundLineY;
                }
                this.bars.push({
                    width: singleBarWidht,
                    height: height,
                    y: y,
                    x: element.position,
                    sourceItem: element.val,
                    calculatedPercent: element.val.value === 0 ? 0 : this.utilsService.roundScale(element.val.value / onePercent),
                    color: element.val.color,
                    id: this.utilsService.createElementId('chart-bar-', index),
                    isMinusValue: isMinusValue
                });
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        BarChartComponent.prototype.onClickSegment = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            _super.prototype.onClickSegment.call(this, event);
            if (event === this.currentActiveChartItem) {
                this.currentActiveBar = event;
            }
            else {
                this.currentActiveBar = null;
            }
        };
        /**
         * @return {?}
         */
        BarChartComponent.prototype.resetActiveElement = /**
         * @return {?}
         */
        function () {
            this.currentActiveBar = null;
            _super.prototype.resetActive.call(this);
        };
        /**
         * @param {?} item
         * @return {?}
         */
        BarChartComponent.prototype.cssClassSegment = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            /** @type {?} */
            var css = '';
            if (this.animationActive) {
                if (this.currentOrientation === ChartOrientation.Bottom || this.currentOrientation === ChartOrientation.Top) {
                    css += ' bar-anim-top-bottom';
                }
                else {
                    css += ' bar-anim-left-right';
                }
            }
            if (item === this.currentActiveChartItem) {
                css += ' bar-selected';
            }
            if (item.sourceItem) {
                if (item.sourceItem.cssClass != null) {
                    css += ' ' + item.sourceItem.cssClass;
                }
            }
            return css;
        };
        Object.defineProperty(BarChartComponent.prototype, "barFillOpacity", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.currentBarFullFilled === true) {
                    return "1";
                }
                return ".5";
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} defaultValue
         * @param {?} rightValue
         * @param {?} leftValue
         * @param {?} topValue
         * @return {?}
         */
        BarChartComponent.prototype.normOrientation = /**
         * @param {?} defaultValue
         * @param {?} rightValue
         * @param {?} leftValue
         * @param {?} topValue
         * @return {?}
         */
        function (defaultValue, rightValue, leftValue, topValue) {
            if (this.currentOrientation === ChartOrientation.Bottom) {
                return defaultValue;
            }
            else if (this.currentOrientation === ChartOrientation.Right) {
                return rightValue;
            }
            else if (this.currentOrientation === ChartOrientation.Left) {
                return leftValue;
            }
            else {
                return topValue;
            }
        };
        BarChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'dl-bar-chart',
                        template: "<ng-container>\r\n  <svg class=\"bar-chart-svg\" width=\"100%\" height=\"100%\">\r\n    <svg id=\"bars\" class=\"bars\" x=\"30px\" y=\"30px\" width=\"calc(100% - 60px)\" height=\"calc(100% - 60px)\">\r\n      <rect (mousemove)=\"onHoverSegment($event, bar)\" (mouseleave)=\"onLeaveSegment($event)\" (click)=\"onClickSegment(bar)\"\r\n        [attr.id]=\"bar.id\" [attr.class]=\"'bar ' + cssClassSegment(bar)\" [attr.fill-opacity]=\"barFillOpacity\" [attr.stroke]=\"bar.color\" [attr.fill]=\"bar.color\" [attr.x]=\"normOrientation(bar.x, bar.y, (bar.isMinusValue === false ? (100 - barGroundLineY) : ((100 - barGroundLineY) - bar.height)), bar.x) + '%'\"\r\n        [attr.width]=\"normOrientation(bar.width, bar.height, bar.height, bar.width) + '%'\" [attr.y]=\"normOrientation(bar.y, bar.x, bar.x, (bar.isMinusValue === false ? (100 - barGroundLineY) : ((100 - barGroundLineY) - bar.height))) + '%'\"\r\n        [attr.height]=\"normOrientation(bar.height, bar.width, bar.width, bar.height) + '%'\" *ngFor=\"let bar of bars\">\r\n      </rect>\r\n      <line id=\"dlChartBarSelectLineIndicator\" *ngIf=\"currentActiveBar != null && !shouldHideSelectLine\" [attr.y1]=\"(currentActiveBar.isMinusValue === false ?  normOrientation((barGroundLineY - currentActiveBar.height), 0, 0, ((100 - barGroundLineY) + currentActiveBar.height)) : normOrientation((barGroundLineY + currentActiveBar.height), 0, 0, ((100 - barGroundLineY) - currentActiveBar.height))) + '%'\"\r\n        [attr.x1]=\"(currentActiveBar.isMinusValue === false ?  normOrientation(0, (barGroundLineY - currentActiveBar.height), ((100 - barGroundLineY) + currentActiveBar.height), 0) : normOrientation(0, (barGroundLineY + currentActiveBar.height), ((100 - barGroundLineY) - currentActiveBar.height), 0)) + '%'\"\r\n        [attr.y2]=\"(currentActiveBar.isMinusValue === false ?  normOrientation((barGroundLineY - currentActiveBar.height), 100, 100, ((100 - barGroundLineY) + currentActiveBar.height)) : normOrientation((barGroundLineY + currentActiveBar.height), 100, 100, ((100 - barGroundLineY) - currentActiveBar.height))) + '%'\"\r\n        [attr.x2]=\"(currentActiveBar.isMinusValue === false ?  normOrientation(100, (barGroundLineY - currentActiveBar.height), ((100 - barGroundLineY) + currentActiveBar.height), 100) : normOrientation(100, (barGroundLineY + currentActiveBar.height), ((100 - barGroundLineY) - currentActiveBar.height), 100)) + '%'\"\r\n        class=\"selection-line active-stroke\" />\r\n      <line id=\"dlChartBarNormalizedLine\" [attr.y1]=\"normOrientation(barGroundLineY, 0, 0, (100 - barGroundLineY)) + '%'\"\r\n        [attr.x1]=\"normOrientation(0, barGroundLineY, (100 - barGroundLineY), 0) + '%'\" [attr.y2]=\"normOrientation(barGroundLineY, 100, 100, (100 - barGroundLineY)) + '%'\"\r\n        [attr.x2]=\"normOrientation(100, barGroundLineY, (100 - barGroundLineY), 100) + '%'\" class=\"ground-line\" />\r\n    </svg>\r\n    <svg xaxis [orientation]=\"currentOrientation\" [xAxis]=\"xAxis\"></svg>\r\n    <svg yaxis [activeScaleAxis]=\"activeLeftScaleAxis\" [orientation]=\"currentOrientation\" [yAxis]=\"yAxis\" [scaleLabel]=\"currentScaleLabel\"></svg>\r\n    <svg yaxis [activeScaleAxis]=\"activeRightScaleAxis\" [orientation]=\"currentOrientation\" [yAxis]=\"yAxis\" [isLeft]=\"false\" [scaleLabel]=\"currentScaleLabel\"></svg>\r\n  </svg>\r\n  <div id=\"dlChartTooltip\" *ngIf=\"tooltipShow\" [style.top.px]=\"tooltipTop\" [style.left.px]=\"tooltipLeft\" class=\"tooltiptext\">\r\n    <span>{{ tooltipValue }}</span>\r\n  </div>\r\n</ng-container>",
                        encapsulation: core.ViewEncapsulation.Emulated,
                        styles: [".tooltiptext{position:fixed;overflow:hidden;text-align:center;padding:5px 10px;border-radius:6px;z-index:80;background-color:#555;color:#fff}.bar{stroke-width:2px}.bar-selected,.bar:hover{opacity:.8;transition:.5s}.bars line{fill:none;shape-rendering:crispEdges;stroke:#000}.selection-line{fill:#000;stroke-width:1;stroke-dasharray:5}.ground-line{fill:#000}.bar-anim-top-bottom{-webkit-animation:.4s 1ms scaleBar;animation:.4s 1ms reverse scaleBar;-webkit-transform-origin:100% 90% 0;transform-origin:100% 90% 0}.bar-anim-left-right{-webkit-animation:.4s 1ms scaleBarX;animation:.4s 1ms reverse scaleBarX;-webkit-transform-origin:100% 90% 0;transform-origin:100% 90% 0}@-webkit-keyframes scaleBar{100%{-webkit-transform:scaleY(0);transform:scaleY(0)}}@keyframes scaleBar{100%{-webkit-transform:scaleY(0);transform:scaleY(0)}}@-webkit-keyframes scaleBarX{100%{-webkit-transform:scaleX(0);transform:scaleX(0)}}@keyframes scaleBarX{100%{-webkit-transform:scaleX(0);transform:scaleX(0)}}"]
                    }] }
        ];
        /** @nocollapse */
        BarChartComponent.ctorParameters = function () { return [
            { type: ChartItemService },
            { type: UtilsService },
            { type: core.ChangeDetectorRef }
        ]; };
        BarChartComponent.propDecorators = {
            barFullFilled: [{ type: core.Input }],
            hideSelectLine: [{ type: core.Input }],
            barOffset: [{ type: core.Input }],
            scaleLabel: [{ type: core.Input }],
            steps: [{ type: core.Input }],
            leftScaleAxis: [{ type: core.Input }],
            rightScaleAxis: [{ type: core.Input }],
            orientation: [{ type: core.Input }]
        };
        return BarChartComponent;
    }(BaseChartComponent));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var YAxisComponent = /** @class */ (function () {
        function YAxisComponent() {
            this.currentOrientation = ChartOrientation.Bottom;
            this.currentActiveScaleAxis = true;
            this.currentYAxis = [];
            this.currentScaleLabel = '';
            this.currentIsLeft = true;
        }
        Object.defineProperty(YAxisComponent.prototype, "orientation", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentOrientation = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(YAxisComponent.prototype, "yAxis", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentYAxis = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(YAxisComponent.prototype, "activeScaleAxis", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentActiveScaleAxis = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(YAxisComponent.prototype, "isLeft", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentIsLeft = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(YAxisComponent.prototype, "scaleLabel", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentScaleLabel = val;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} defaultValue
         * @param {?} rightValue
         * @param {?} leftValue
         * @param {?} topValue
         * @param {?} defaultValueRight
         * @param {?} rightValueRight
         * @param {?} leftValueRight
         * @param {?} topValueRight
         * @return {?}
         */
        YAxisComponent.prototype.normOrientation = /**
         * @param {?} defaultValue
         * @param {?} rightValue
         * @param {?} leftValue
         * @param {?} topValue
         * @param {?} defaultValueRight
         * @param {?} rightValueRight
         * @param {?} leftValueRight
         * @param {?} topValueRight
         * @return {?}
         */
        function (defaultValue, rightValue, leftValue, topValue, defaultValueRight, rightValueRight, leftValueRight, topValueRight) {
            if (this.currentOrientation === ChartOrientation.Bottom) {
                if (this.currentIsLeft) {
                    return defaultValue;
                }
                else {
                    return defaultValueRight;
                }
            }
            else if (this.currentOrientation === ChartOrientation.Right) {
                if (this.currentIsLeft) {
                    return rightValue;
                }
                else {
                    return rightValueRight;
                }
            }
            else if (this.currentOrientation === ChartOrientation.Left) {
                if (this.currentIsLeft) {
                    return leftValue;
                }
                else {
                    return leftValueRight;
                }
            }
            else {
                if (this.currentIsLeft) {
                    return topValue;
                }
                else {
                    return topValueRight;
                }
            }
        };
        YAxisComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[yaxis]',
                        template: "<svg id=\"yaxis\" \r\n[attr.x]=\"normOrientation('0%', '30px', '30px', 'calc(100% - 30px)', 'calc(100% - 30px)', '30px', '30px', '0%')\" \r\n[attr.y]=\"normOrientation('30px', 'calc(100% - 30px)', '0px', '30px', '30px', '0px', 'calc(100% - 30px)', '30px')\" \r\n[attr.width]=\"normOrientation('30px', 'calc(100% - 60px)', 'calc(100% - 60px)', '30px', '30px', 'calc(100% - 60px)', 'calc(100% - 60px)', '30px')\" \r\n[attr.height]=\"normOrientation('calc(100% - 60px)', '30px', '30px', 'calc(100% - 60px)', 'calc(100% - 60px)', '30px', '30px', 'calc(100% - 60px)')\" style=\"overflow: visible;\">\r\n  <g class=\"y axis\" *ngIf=\"currentActiveScaleAxis\">\r\n    <g class=\"tick\" *ngFor=\"let axis of currentYAxis\">\r\n      <line [attr.x1]=\"normOrientation('calc(100% - 6px)', axis.position + '%', (100 - axis.position) + '%', 0, 0, axis.position + '%', (100 - axis.position) + '%', 'calc(100% - 6px)')\" \r\n      [attr.x2]=\"normOrientation('100%', axis.position + '%', (100 - axis.position) + '%', 6, 6, axis.position + '%', (100 - axis.position) + '%', '100%')\" \r\n      [attr.y1]=\"normOrientation(axis.position + '%', '0', '30px', (100 - axis.position) + '%', axis.position + '%', '30px', 0, (100 - axis.position) + '%')\" \r\n      [attr.y2]=\"normOrientation(axis.position + '%', '6', '24px', (100 - axis.position) + '%', axis.position + '%', '24px', 6, (100 - axis.position) + '%')\"></line>\r\n      <text dy=\".32em\" \r\n      [attr.x]=\"normOrientation('75%', axis.position + '%', (100 - axis.position) + '%', '8', '8', axis.position + '%', (100 - axis.position) + '%', '75%')\" \r\n      [attr.y]=\"normOrientation(axis.position + '%', '12px', '18px', (100 - axis.position) + '%', axis.position + '%', '18px', '12px', (100 - axis.position) + '%')\" \r\n      [style.text-anchor]=\"normOrientation('end', 'middle', 'middle', 'start', 'start', 'middle', 'middle', 'end')\">{{ axis.text }}</text>\r\n    </g>\r\n    <line\r\n    [attr.x1]=\"normOrientation('100%', '0', '0', 0, 0, '0', 0, '100%')\" \r\n    [attr.x2]=\"normOrientation('100%', '100%', '100%', 0, 0, '100%', '100%', '100%')\" \r\n    [attr.y1]=\"normOrientation('0%', '0', '30px', '0%', '0%', '30px', 0, '0%')\" \r\n    [attr.y2]=\"normOrientation('100%', '0', '30px', '100%', '100%', '30px', 0, '100%')\" \r\n    class=\"x-stroke\" />\r\n  </g>\r\n</svg>\r\n<svg *ngIf=\"currentActiveScaleAxis\" \r\n[attr.x]=\"normOrientation('31px', '30px', 'calc(100% - 30px)', 'calc(100% - 43px)', 'calc(100% - 43px)', '30px', 'calc(100% - 31px)', '31px')\" \r\n[attr.y]=\"normOrientation('30px', 'calc(100% - 43px)', '31px', 'calc(100% - 31px)', '30px', '31px', 'calc(100% - 43px)', 'calc(100% - 31px)')\">\r\n  <text dy=\".71em\" \r\n  [attr.x]=\"'0'\" \r\n  [attr.y]=\"'0'\" \r\n  [ngStyle]=\"{'transform': normOrientation('rotate(-90deg)', 'rotate(0deg)', 'rotate(0deg)', 'rotate(-90deg)', 'rotate(-90deg)', 'rotate(0deg)', 'rotate(0deg)', 'rotate(-90deg)'), 'text-anchor': normOrientation('end', 'start', 'end', 'start', 'end', 'start', 'end', 'start')}\">{{ currentScaleLabel }}</text>\r\n</svg>",
                        styles: [".axis{font:10px sans-serif}.axis line,.axis path{fill:none;stroke:#000}.axis text{fill:#000}"]
                    }] }
        ];
        YAxisComponent.propDecorators = {
            orientation: [{ type: core.Input }],
            yAxis: [{ type: core.Input }],
            activeScaleAxis: [{ type: core.Input }],
            isLeft: [{ type: core.Input }],
            scaleLabel: [{ type: core.Input }]
        };
        return YAxisComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var XAxisComponent = /** @class */ (function () {
        function XAxisComponent() {
            this.currentOrientation = ChartOrientation.Bottom;
            this.currentXAxis = [];
        }
        Object.defineProperty(XAxisComponent.prototype, "orientation", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentOrientation = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(XAxisComponent.prototype, "xAxis", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentXAxis = val;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} defaultValue
         * @param {?} rightValue
         * @param {?} leftValue
         * @param {?} topValue
         * @return {?}
         */
        XAxisComponent.prototype.normOrientation = /**
         * @param {?} defaultValue
         * @param {?} rightValue
         * @param {?} leftValue
         * @param {?} topValue
         * @return {?}
         */
        function (defaultValue, rightValue, leftValue, topValue) {
            if (this.currentOrientation === ChartOrientation.Bottom) {
                return defaultValue;
            }
            else if (this.currentOrientation === ChartOrientation.Right) {
                return rightValue;
            }
            else if (this.currentOrientation === ChartOrientation.Left) {
                return leftValue;
            }
            else {
                return topValue;
            }
        };
        XAxisComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[xaxis]',
                        template: "<svg id=\"xaxis\" [attr.x]=\"normOrientation('30px', 'calc(100% - 30px)', '0%', '30px')\"\r\n  [attr.y]=\"normOrientation('calc(100% - 30px)', '30px', '30px', '0px')\"\r\n  [attr.width]=\"normOrientation('calc(100% - 60px)', '30px', '30px', 'calc(100% - 60px)')\"\r\n  [attr.height]=\"normOrientation( '30px', 'calc(100% - 60px)', 'calc(100% - 60px)', '30px')\" style=\"overflow: visible;\">\r\n  <g class=\"x axis xaxis-text\">\r\n    <g class=\"tick\" *ngFor=\"let axis of currentXAxis\">\r\n      <line [attr.x1]=\"normOrientation(axis.position + '%', '0', 'calc(100% - 6px)', (100 - axis.position) + '%')\"\r\n        [attr.x2]=\"normOrientation(axis.position + '%', 4, '100%', (100 - axis.position) + '%')\"\r\n        [attr.y1]=\"normOrientation(0, axis.position + '%', (100 - axis.position) + '%', '30px')\"\r\n        [attr.y2]=\"normOrientation(4, axis.position + '%', (100 - axis.position) + '%', '24px')\"></line>\r\n      <text [attr.dy]=\"normOrientation('.71em', '.31em', '.32em', '.32em')\"\r\n        [attr.x]=\"normOrientation(axis.position + '%', '6', '75%', (100 - axis.position) + '%')\"\r\n        [attr.y]=\"normOrientation('6', axis.position + '%', axis.position + '%', '18px')\"\r\n        [ngStyle]=\"{'text-anchor': normOrientation('middle', 'start', 'end', 'middle')}\">{{\r\n            axis.text }}</text>\r\n    </g>\r\n    <line id=\"dlChartBarXLine\" [attr.x1]=\"normOrientation(0, 0, '100%', '0')\"\r\n      [attr.y1]=\"normOrientation(0, 0, '0%', '30px')\" [attr.x2]=\"normOrientation('100%', 0, '100%', '100%')\"\r\n      [attr.y2]=\"normOrientation(0, '100%', '100%', '30px')\" class=\"x-stroke\" />\r\n  </g>\r\n</svg>",
                        styles: [".axis{font:10px sans-serif}.axis line,.axis path{fill:none;stroke:#000}.axis text{fill:#000}"]
                    }] }
        ];
        XAxisComponent.propDecorators = {
            orientation: [{ type: core.Input }],
            xAxis: [{ type: core.Input }]
        };
        return XAxisComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AxisComponentsModule = /** @class */ (function () {
        function AxisComponentsModule() {
        }
        AxisComponentsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule
                        ],
                        declarations: [
                            YAxisComponent,
                            XAxisComponent
                        ],
                        providers: [],
                        entryComponents: [],
                        exports: [
                            YAxisComponent,
                            XAxisComponent
                        ]
                    },] }
        ];
        return AxisComponentsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DlBarChartModule = /** @class */ (function () {
        function DlBarChartModule() {
        }
        DlBarChartModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            AxisComponentsModule,
                            common.CommonModule
                        ],
                        declarations: [
                            BarChartComponent
                        ],
                        providers: [
                            ChartItemService,
                            UtilsService
                        ],
                        entryComponents: [
                            BarChartComponent
                        ],
                        exports: [
                            BarChartComponent
                        ]
                    },] }
        ];
        return DlBarChartModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LineChartComponent = /** @class */ (function (_super) {
        __extends(LineChartComponent, _super);
        function LineChartComponent(chartItemService, utilsService, cd) {
            var _this = _super.call(this, chartItemService, utilsService, cd) || this;
            _this.currentScaleLabel = '';
            _this.valueSteps = 6;
            _this.activeLeftScaleAxis = true;
            _this.activeRightScaleAxis = false;
            _this.activeHideRaster = false;
            _this.activeHideLines = false;
            _this.activeHideLinesFiller = false;
            _this.activeHidePoints = false;
            _this.activeHideSelectionLines = false;
            _this.xAxis = [];
            _this.yAxis = [];
            _this.axisPoint = [];
            return _this;
        }
        Object.defineProperty(LineChartComponent.prototype, "scaleLabel", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.currentScaleLabel = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineChartComponent.prototype, "steps", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.valueSteps = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineChartComponent.prototype, "leftScaleAxis", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.activeLeftScaleAxis = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineChartComponent.prototype, "rightScaleAxis", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.activeRightScaleAxis = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineChartComponent.prototype, "hideRaster", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.activeHideRaster = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineChartComponent.prototype, "hideLines", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.activeHideLines = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineChartComponent.prototype, "hideLinesFiller", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.activeHideLinesFiller = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineChartComponent.prototype, "hidePoints", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.activeHidePoints = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineChartComponent.prototype, "hideSelectionLines", {
            set: /**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                this.activeHideSelectionLines = val;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} changes
         * @return {?}
         */
        LineChartComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            if (changes.steps == undefined && changes.values != undefined && ((/** @type {?} */ (changes.values.currentValue))) != undefined && ((/** @type {?} */ (changes.values.previousValue))) != undefined) {
                if (!this.compare(changes.values.currentValue, changes.values.previousValue)) {
                    this.resetActiveElement();
                    this.calculateChart();
                }
            }
            else {
                this.resetActiveElement();
                this.calculateChart();
            }
        };
        /**
         * @param {?} arr1
         * @param {?} arr2
         * @return {?}
         */
        LineChartComponent.prototype.compare = /**
         * @param {?} arr1
         * @param {?} arr2
         * @return {?}
         */
        function (arr1, arr2) {
            var _this = this;
            if (!arr1 || !arr2)
                return;
            /** @type {?} */
            var result = false;
            arr1.forEach((/**
             * @param {?} e1
             * @param {?} i
             * @return {?}
             */
            function (e1, i) { return arr2.forEach((/**
             * @param {?} e2
             * @return {?}
             */
            function (e2) {
                if (e1.length > 1 && e2.length) {
                    result = _this.compare(e1, e2);
                }
                else if (e1 !== e2) {
                    result = false;
                }
                else {
                    result = true;
                }
            })); }));
            return result;
        };
        /**
         * @return {?}
         */
        LineChartComponent.prototype.calculateChart = /**
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var items = this.currentValues;
            /** @type {?} */
            var uniqueXPoints = [];
            /** @type {?} */
            var uniqueYPoints = [];
            items.forEach((/**
             * @param {?} val
             * @return {?}
             */
            function (val) {
                val.points.forEach((/**
                 * @param {?} point
                 * @return {?}
                 */
                function (point) {
                    if (!uniqueXPoints.some((/**
                     * @param {?} e
                     * @return {?}
                     */
                    function (e) { return e === point.xValue; }))) {
                        uniqueXPoints.push(point.xValue);
                    }
                    if (!uniqueYPoints.some((/**
                     * @param {?} e
                     * @return {?}
                     */
                    function (e) { return e === point.yValue; }))) {
                        uniqueYPoints.push(point.yValue);
                    }
                }));
            }));
            /** @type {?} */
            var xMinValue = Math.min.apply(Math, uniqueXPoints.map((/**
             * @param {?} o
             * @return {?}
             */
            function (o) { return o; })));
            /** @type {?} */
            var xMaxValue = Math.max.apply(Math, uniqueXPoints.map((/**
             * @param {?} o
             * @return {?}
             */
            function (o) { return o; })));
            /** @type {?} */
            var onePercentX = (xMaxValue - xMinValue) / 100;
            /** @type {?} */
            var yMinValue = Math.min.apply(Math, uniqueYPoints.map((/**
             * @param {?} o
             * @return {?}
             */
            function (o) { return o; })));
            /** @type {?} */
            var yMaxValue = Math.max.apply(Math, uniqueYPoints.map((/**
             * @param {?} o
             * @return {?}
             */
            function (o) { return o; })));
            /** @type {?} */
            var useMaxValueY = (yMaxValue - yMinValue);
            /** @type {?} */
            var singleStepY = (100 / this.valueSteps);
            /** @type {?} */
            var singleStepYValue = (useMaxValueY / this.valueSteps);
            this.yAxis = this.utilsService.createYAxis(yMinValue, this.valueSteps, singleStepYValue, singleStepY, yMaxValue);
            // sort the uniqueXPoints
            uniqueXPoints = uniqueXPoints.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) {
                if (a > b) {
                    return 0;
                }
                return 1;
            }));
            /** @type {?} */
            var xA = [];
            /** @type {?} */
            var index = 0;
            for (index = 0; index < (uniqueXPoints.length); index++) {
                xA.push(uniqueXPoints[index].toString());
            }
            this.xAxis = this.createAxis(xA, 100);
            this.axisPoint = [];
            /** @type {?} */
            var oneValueYPercent = useMaxValueY / 100;
            var _loop_1 = function () {
                /** @type {?} */
                var element = items[index];
                /** @type {?} */
                var pointAxis = [];
                /** @type {?} */
                var indexPoints = 0;
                /** @type {?} */
                var subItemId = this_1.utilsService.createElementId('chart-line-point-', index);
                element.points.forEach((/**
                 * @param {?} point
                 * @return {?}
                 */
                function (point) {
                    /** @type {?} */
                    var x = ((point.xValue - xMinValue) / onePercentX);
                    /** @type {?} */
                    var percentValueY = _this.utilsService.roundScale((point.yValue - yMinValue) / oneValueYPercent);
                    /** @type {?} */
                    var displayValueY = _this.utilsService.roundScale(percentValueY * 1);
                    /** @type {?} */
                    var y = 100 - displayValueY;
                    if (point.name === '' || point.name === null || point.name === undefined) {
                        point.name = element.name;
                    }
                    pointAxis.push({
                        x: x,
                        y: y,
                        size: 5,
                        sourceItem: point,
                        calculatedPercent: _this.utilsService.roundScale((point.xValue - xMinValue) / onePercentX),
                        color: point.color === null ? element.color : point.color,
                        id: _this.utilsService.createElementId(subItemId + '-', indexPoints),
                    });
                    indexPoints++;
                }));
                this_1.axisPoint.push({
                    points: pointAxis,
                    sourceItem: element,
                    calculatedPercent: null,
                    color: element.color,
                    id: this_1.utilsService.createElementId('chart-line-axis-', index),
                });
            };
            var this_1 = this;
            for (index = 0; index < items.length; index++) {
                _loop_1();
            }
            this.chartItemService.setChartValues(new ServiceItem(this.chartid, this.axisPoint, null, null));
        };
        /**
         * @param {?} points
         * @return {?}
         */
        LineChartComponent.prototype.getPathFromAxisLine = /**
         * @param {?} points
         * @return {?}
         */
        function (points) {
            /** @type {?} */
            var path = "";
            points.forEach((/**
             * @param {?} line
             * @return {?}
             */
            function (line) {
                if (path != "") {
                    path += " ";
                }
                path += line.x + "," + line.y;
            }));
            return path;
        };
        /**
         * @param {?} items
         * @param {?} length
         * @return {?}
         */
        LineChartComponent.prototype.createAxis = /**
         * @param {?} items
         * @param {?} length
         * @return {?}
         */
        function (items, length) {
            /** @type {?} */
            var axis = [];
            /** @type {?} */
            var step = (length / (items.length - 1));
            for (var index = 0; index < (items.length); index++) {
                /** @type {?} */
                var element = items[index];
                axis.push({
                    text: element,
                    position: (100 - (length - (step * index))),
                });
            }
            return axis;
        };
        /**
         * @return {?}
         */
        LineChartComponent.prototype.resetActiveElement = /**
         * @return {?}
         */
        function () {
            _super.prototype.resetActive.call(this);
        };
        /**
         * @param {?} event
         * @param {?} aPoint
         * @return {?}
         */
        LineChartComponent.prototype.onClickSegmentPoint = /**
         * @param {?} event
         * @param {?} aPoint
         * @return {?}
         */
        function (event, aPoint) {
            event.id = aPoint.id;
            _super.prototype.onClickSegment.call(this, event);
        };
        /**
         * @param {?} item
         * @return {?}
         */
        LineChartComponent.prototype.cssClassSegmentLine = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            /** @type {?} */
            var css = '';
            if (this.animationActive) {
                css += ' line-anim';
            }
            if (item === this.currentActiveChartItem) {
                css += ' ';
            }
            if (item.sourceItem.cssClass != null) {
                css += ' ' + item.sourceItem.cssClass;
            }
            return css;
        };
        /**
         * @param {?} item
         * @return {?}
         */
        LineChartComponent.prototype.cssClassSegmentPoint = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            /** @type {?} */
            var css = '';
            if (this.animationActive) {
                css += ' point-anim';
            }
            if (item === this.currentActiveChartItem) {
                css += ' point-selected';
            }
            if (item.sourceItem.cssClass != null) {
                css += ' ' + item.sourceItem.cssClass;
            }
            return css;
        };
        /**
         * @param {?} item
         * @return {?}
         */
        LineChartComponent.prototype.pointSize = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            if (item === this.currentActiveChartItem) {
                return item.size + 2;
            }
            return item.size;
        };
        Object.defineProperty(LineChartComponent.prototype, "currentActivePoint", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.currentActiveChartItem != null) {
                    /** @type {?} */
                    var point = (/** @type {?} */ (this.currentActiveChartItem));
                    if (point != undefined && point.x != undefined) {
                        return point;
                    }
                }
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineChartComponent.prototype, "selectionXEndPoint", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.currentActiveChartItem != null) {
                    /** @type {?} */
                    var point = (/** @type {?} */ (this.currentActiveChartItem));
                    if (point.x > 50) {
                        if (this.activeRightScaleAxis === true) {
                            return 100;
                        }
                        else {
                            return 0;
                        }
                    }
                    else {
                        if (this.activeLeftScaleAxis === true) {
                            return 0;
                        }
                        else {
                            return 100;
                        }
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        LineChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'dl-line-chart',
                        template: "<ng-container>\r\n  <svg class=\"line-chart-svg\" width=\"100%\" height=\"100%\">\r\n    <svg xaxis [orientation]=\"0\" [xAxis]=\"xAxis\"></svg>\r\n    <svg yaxis [activeScaleAxis]=\"activeLeftScaleAxis\" [orientation]=\"0\" [yAxis]=\"yAxis\" [scaleLabel]=\"currentScaleLabel\"></svg>\r\n    <svg yaxis [activeScaleAxis]=\"activeRightScaleAxis\" [orientation]=\"0\" [yAxis]=\"yAxis\" [isLeft]=\"false\" [scaleLabel]=\"currentScaleLabel\"></svg>\r\n    <svg width=\"calc(100% - 60px)\" height=\"calc(100% - 60px)\" x=\"30px\" y=\"30px\" style=\"overflow: visible;\">\r\n      <g *ngIf=\"!activeHideRaster\" class=\"raster\" id=\"background-raster\">\r\n        <line class=\"background-raster\" [attr.x1]=\"axis.position + '%'\" [attr.x2]=\"axis.position + '%'\" y1=\"0\" y2=\"100%\"\r\n          *ngFor=\"let axis of xAxis\"></line>\r\n        <line class=\"background-raster\" [attr.y1]=\"axis.position + '%'\" [attr.y2]=\"axis.position + '%'\" x1=\"0\" x2=\"100%\"\r\n          *ngFor=\"let axis of yAxis\"></line>\r\n      </g>\r\n      <svg *ngIf=\"!activeHideLines\" width=\"100%\" height=\"100%\" viewBox=\"0 0 100 100\" preserveAspectRatio=\"none\" style=\"overflow:visible\">\r\n        <g *ngFor=\"let axis of axisPoint\">\r\n          <polyline class=\"line cssClassSegmentLine(axis)\" fill=\"none\" [attr.stroke]=\"axis.color\" stroke-width=\"1\" [attr.points]=\"getPathFromAxisLine(axis.points)\" />\r\n          <polygon *ngIf=\"!activeHideLinesFiller\" class=\"line-filler\" [attr.fill]=\"axis.color\" stroke=\"none\"\r\n            [attr.points]=\"getPathFromAxisLine(axis.points) + ' 100,100 0,100'\" />\r\n        </g>\r\n      </svg>\r\n      <g *ngIf=\"!activeHideSelectionLines && currentActivePoint != null\" id=\"selection\">\r\n        <line class=\"point-selected x-point-selected\" x2=\"0\" [attr.y2]=\"currentActivePoint.y + '%'\" [attr.x2]=\"currentActivePoint.x + '%'\"\r\n          [attr.y1]=\"'100%'\" [attr.x1]=\"currentActivePoint.x + '%'\"></line>\r\n        <line class=\"point-selected y-point-selected\" [attr.x1]=\"selectionXEndPoint + '%'\" [attr.x2]=\"currentActivePoint.x+ '%'\"\r\n          [attr.y2]=\"currentActivePoint.y+ '%'\" [attr.y1]=\"currentActivePoint.y+ '%'\"></line>\r\n      </g>\r\n      <g [attr.class]=\"'line-axis line-axis-anim'\" *ngFor=\"let axis of axisPoint\">\r\n        <g *ngIf=\"!activeHidePoints\" id=\"selection-point\">\r\n          <circle *ngFor=\"let point of axis.points\" (mousemove)=\"onHoverSegment($event, point)\" (mouseleave)=\"onLeaveSegment($event)\"\r\n            (click)=\"onClickSegmentPoint(point, axis)\" [attr.id]=\"point.id\" [attr.class]=\"'point ' + cssClassSegmentPoint(point)\"\r\n            [attr.fill]=\"point.color\" [attr.cx]=\"point.x + '%'\" [attr.cy]=\"point.y + '%'\" [attr.r]=\"pointSize(point)\" />\r\n        </g>\r\n      </g>\r\n    </svg>\r\n  </svg>\r\n  <div id=\"dlChartTooltip\" *ngIf=\"tooltipShow\" [style.top.px]=\"tooltipTop\" [style.left.px]=\"tooltipLeft\" class=\"tooltiptext\">\r\n    <span>{{ tooltipValue }}</span>\r\n  </div>\r\n</ng-container>",
                        encapsulation: core.ViewEncapsulation.Emulated,
                        styles: [".tooltiptext{position:fixed;overflow:hidden;text-align:center;padding:5px 10px;border-radius:6px;z-index:80;background-color:#555;color:#fff}.raster line{fill:none;stroke:#000}.background-raster{opacity:.1}.point-anim{transition:.5s;-webkit-animation:.4s showPoint;animation:.4s reverse showPoint}.line{opacity:.8}.line-filler{opacity:.3}.line-anim{transition:.5s;stroke-dasharray:1000;stroke-dashoffset:1000;-webkit-animation:.5s linear forwards dash;animation:.5s linear forwards dash}.point-selected{transition:.5s;stroke-width:3px;stroke:#000}@-webkit-keyframes showPoint{100%{opacity:0}}@keyframes showPoint{100%{opacity:0}}@-webkit-keyframes dash{from{stroke-dashoffset:1000}to{stroke-dashoffset:0}}@keyframes dash{from{stroke-dashoffset:1000}to{stroke-dashoffset:0}}"]
                    }] }
        ];
        /** @nocollapse */
        LineChartComponent.ctorParameters = function () { return [
            { type: ChartItemService },
            { type: UtilsService },
            { type: core.ChangeDetectorRef }
        ]; };
        LineChartComponent.propDecorators = {
            scaleLabel: [{ type: core.Input }],
            steps: [{ type: core.Input }],
            leftScaleAxis: [{ type: core.Input }],
            rightScaleAxis: [{ type: core.Input }],
            hideRaster: [{ type: core.Input }],
            hideLines: [{ type: core.Input }],
            hideLinesFiller: [{ type: core.Input }],
            hidePoints: [{ type: core.Input }],
            hideSelectionLines: [{ type: core.Input }]
        };
        return LineChartComponent;
    }(BaseChartComponent));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DlLineChartModule = /** @class */ (function () {
        function DlLineChartModule() {
        }
        DlLineChartModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            AxisComponentsModule,
                            common.CommonModule
                        ],
                        declarations: [
                            LineChartComponent
                        ],
                        providers: [
                            ChartItemService,
                            UtilsService
                        ],
                        entryComponents: [
                            LineChartComponent
                        ],
                        exports: [
                            LineChartComponent
                        ]
                    },] }
        ];
        return DlLineChartModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DlChartModule = /** @class */ (function () {
        function DlChartModule() {
        }
        DlChartModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            DlPieChartModule,
                            DlLegendModule,
                            DlBarChartModule,
                            DlLineChartModule
                        ],
                        declarations: [],
                        providers: [],
                        exports: [
                            DlPieChartModule,
                            DlLegendModule,
                            DlBarChartModule,
                            DlLineChartModule
                        ]
                    },] }
        ];
        return DlChartModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Value = /** @class */ (function () {
        function Value(name, value, color, cssClass, tooltipConfig, data, shortName) {
            if (cssClass === void 0) { cssClass = null; }
            if (tooltipConfig === void 0) { tooltipConfig = null; }
            if (data === void 0) { data = null; }
            if (shortName === void 0) { shortName = null; }
            this.shortName = null;
            this.cssClass = null;
            this.tooltipConfig = null;
            this.data = null;
            this.name = name;
            this.value = value;
            this.color = color;
            this.cssClass = cssClass;
            this.tooltipConfig = tooltipConfig;
            this.data = data;
            this.shortName = shortName;
        }
        return Value;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Point = /** @class */ (function () {
        function Point(xValue, yValue, name, color, cssClass, tooltipConfig, data) {
            if (name === void 0) { name = null; }
            if (color === void 0) { color = null; }
            if (cssClass === void 0) { cssClass = null; }
            if (tooltipConfig === void 0) { tooltipConfig = null; }
            if (data === void 0) { data = null; }
            this.name = null;
            this.color = null;
            this.cssClass = null;
            this.tooltipConfig = null;
            this.data = null;
            this.xValue = xValue;
            this.yValue = yValue;
            this.name = name;
            this.color = color;
            this.cssClass = cssClass;
            this.tooltipConfig = tooltipConfig;
            this.data = data;
        }
        return Point;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Line = /** @class */ (function () {
        function Line(name, points, color, cssClass, tooltipConfig, data) {
            if (cssClass === void 0) { cssClass = null; }
            if (tooltipConfig === void 0) { tooltipConfig = null; }
            if (data === void 0) { data = null; }
            this.cssClass = null;
            this.tooltipConfig = null;
            this.data = null;
            this.name = name;
            this.points = points;
            this.color = color;
            this.cssClass = cssClass;
            this.tooltipConfig = tooltipConfig;
            this.data = data;
        }
        return Line;
    }());

    exports.ChartItemService = ChartItemService;
    exports.ChartOrientation = ChartOrientation;
    exports.DlBarChartModule = DlBarChartModule;
    exports.DlChartModule = DlChartModule;
    exports.DlLegendModule = DlLegendModule;
    exports.DlLineChartModule = DlLineChartModule;
    exports.DlPieChartModule = DlPieChartModule;
    exports.LegendConfiguration = LegendConfiguration;
    exports.Line = Line;
    exports.Point = Point;
    exports.ServiceItem = ServiceItem;
    exports.TooltipConfiguration = TooltipConfiguration;
    exports.Value = Value;
    exports.ɵa = PieChartComponent;
    exports.ɵb = BaseChartComponent;
    exports.ɵc = UtilsService;
    exports.ɵd = LegendComponent;
    exports.ɵe = AxisComponentsModule;
    exports.ɵf = YAxisComponent;
    exports.ɵg = XAxisComponent;
    exports.ɵh = BarChartComponent;
    exports.ɵi = LineChartComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=dl-chart.umd.js.map
