import { OnChanges, SimpleChanges, ChangeDetectorRef } from '@angular/core';
import { ChartItemService } from '../services/chart-item.service';
import { Value } from '../models/value.model';
import { Bar } from '../models/bar.model';
import { Axis } from '../models/axis.model';
import { ChartOrientation } from '../models/enums';
import { BaseChartComponent } from '../shared/base-chart.component';
import { UtilsService } from '../services/utils.service';
export declare class BarChartComponent extends BaseChartComponent<Value> implements OnChanges {
    barWidhtOffset: number;
    currentActiveBar: Bar;
    shouldHideSelectLine: boolean;
    currentScaleLabel: string;
    valueSteps: number;
    activeLeftScaleAxis: boolean;
    activeRightScaleAxis: boolean;
    currentOrientation: ChartOrientation;
    currentBarFullFilled: boolean;
    barGroundLineY: number;
    xAxis: Axis[];
    yAxis: Axis[];
    bars: Bar[];
    barFullFilled: boolean;
    hideSelectLine: boolean;
    barOffset: number;
    scaleLabel: string;
    steps: number;
    leftScaleAxis: boolean;
    rightScaleAxis: boolean;
    orientation: ChartOrientation;
    constructor(chartItemService: ChartItemService, utilsService: UtilsService, cd: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    calculateChart(): void;
    createXAxis(singleBarWidht: number, items: {
        val: Value;
        position: number;
    }[]): void;
    createBars(maxValue: number, singleBarWidht: number, items: {
        val: Value;
        position: number;
    }[]): void;
    onClickSegment(event: Bar): void;
    resetActiveElement(): void;
    cssClassSegment(item: Bar): string;
    readonly barFillOpacity: string;
    normOrientation(defaultValue: any, rightValue: any, leftValue: any, topValue: any): any;
}
