import { OnInit, AfterViewInit, EventEmitter, ChangeDetectorRef, AfterContentChecked } from '@angular/core';
import { ChartItemService } from '../services/chart-item.service';
import { IChartItem } from '../models/chartitem.interface';
import { LegendConfiguration } from '../models/legendconfiguration.model';
import { ServiceItem } from '../models/serviceitem.model';
import { IValue } from '../models/value.interface';
import { UtilsService } from '../services/utils.service';
export declare class LegendComponent implements OnInit, AfterViewInit, AfterContentChecked {
    chartItemService: ChartItemService;
    private utilsService;
    private cd;
    legendClick: EventEmitter<IValue>;
    items: ServiceItem<IChartItem[]>;
    hoverItem: IChartItem;
    selectedItem: IChartItem;
    shouldHideChartHoverEffect: boolean;
    shouldHideChartSelectEffect: boolean;
    chartidChange: EventEmitter<string>;
    chartid: string;
    currentChartid: string;
    readonly chartItems: IChartItem[];
    hideChartHoverEffect: boolean;
    hideChartSelectEffect: boolean;
    legendConfiguration: LegendConfiguration;
    currentLegendConfiguration: LegendConfiguration;
    constructor(chartItemService: ChartItemService, utilsService: UtilsService, cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngAfterContentChecked(): void;
    legendTextValue(item: IChartItem): string;
    tooltipTextValue(item: IChartItem): string;
    onItemClick(event: any, item: IChartItem): void;
    legendClass(item: IChartItem): string;
}
