import { OnChanges, SimpleChanges, ChangeDetectorRef } from '@angular/core';
import { ChartItemService } from '../services/chart-item.service';
import { Axis } from '../models/axis.model';
import { Line } from '../models/line.model';
import { LinePoint } from '../models/linepoint.model';
import { AxisPoint } from '../models/axispoint.model';
import { BaseChartComponent } from '../shared/base-chart.component';
import { UtilsService } from '../services/utils.service';
export declare class LineChartComponent extends BaseChartComponent<Line> implements OnChanges {
    currentScaleLabel: string;
    valueSteps: number;
    activeLeftScaleAxis: boolean;
    activeRightScaleAxis: boolean;
    activeHideRaster: boolean;
    activeHideLines: boolean;
    activeHideLinesFiller: boolean;
    activeHidePoints: boolean;
    activeHideSelectionLines: boolean;
    xAxis: Axis[];
    yAxis: Axis[];
    axisPoint: AxisPoint[];
    scaleLabel: string;
    steps: number;
    leftScaleAxis: boolean;
    rightScaleAxis: boolean;
    hideRaster: boolean;
    hideLines: boolean;
    hideLinesFiller: boolean;
    hidePoints: boolean;
    hideSelectionLines: boolean;
    constructor(chartItemService: ChartItemService, utilsService: UtilsService, cd: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    compare(arr1: any, arr2: any): boolean;
    calculateChart(): void;
    getPathFromAxisLine(points: LinePoint[]): string;
    createAxis(items: string[], length: number): Axis[];
    resetActiveElement(): void;
    onClickSegmentPoint(event: LinePoint, aPoint: AxisPoint): void;
    cssClassSegmentLine(item: AxisPoint): string;
    cssClassSegmentPoint(item: LinePoint): string;
    pointSize(item: LinePoint): number;
    readonly currentActivePoint: LinePoint;
    readonly selectionXEndPoint: 0 | 100;
}
