import { ChartItemService } from '../services/chart-item.service';
import { EventEmitter, ChangeDetectorRef } from '@angular/core';
import { TooltipConfiguration } from '../models/tooltipconfiguration.model';
import { IChartItem } from '../models/chartitem.interface';
import { IValue } from '../models/value.interface';
import { UtilsService } from '../services/utils.service';
export declare class BaseChartComponent<T> {
    chartItemService: ChartItemService;
    utilsService: UtilsService;
    cd: ChangeDetectorRef;
    currentValues: T[];
    tooltipLeft: number;
    tooltipTop: number;
    tooltipShow: boolean;
    tooltipContentItem: IValue;
    tooltipContentChartItem: IChartItem;
    tooltipClass: string;
    currentActiveChartItem: IChartItem;
    animationActive: boolean;
    values: T[];
    animation: boolean;
    valueSelect: EventEmitter<IValue>;
    valueDeselect: EventEmitter<IValue>;
    valueClick: EventEmitter<IValue>;
    valueChange: EventEmitter<IValue>;
    chartidChange: EventEmitter<string>;
    chartid: string;
    currentChartid: string;
    tooltipConfiguration: TooltipConfiguration;
    currentTooltipConfiguration: TooltipConfiguration;
    hideTooltip: boolean;
    currentHideTooltip: boolean;
    allowSelect: boolean;
    currentAllowSelect: boolean;
    readonly tooltipValue: string;
    constructor(chartItemService: ChartItemService, utilsService: UtilsService, cd: ChangeDetectorRef);
    onClickSegment(event: IChartItem): void;
    onHoverSegment(event: any, item: IChartItem): void;
    onLeaveSegment(event: any): void;
    resetActive(): void;
}
